#define com_maroontress_libcgi_Request_IMPORT
#define com_maroontress_libcgi_mime_ContentType_IMPORT
#define com_maroontress_libcgi_request_Map_IMPORT
#define com_maroontress_libcgi_request_MappedRequest_IMPORT
#define std_io_OutputTube_IMPORT

#include <stdlib.h>
#include <string.h>
#include <com/maroontress/libcgi/Request.h>
#include <com/maroontress/libcgi/mime/ContentType.h>
#include <com/maroontress/libcgi/request/Map.h>
#include <com/maroontress/libcgi/request/MappedRequest.h>
#include <std/io/OutputTube.h>

union Request_Impl {
    struct Request request;
    struct MappedRequest mappedRequest;
};

static void
destroy(union Request_Impl *impl)
{
    Map_free(impl->mappedRequest.map);
    free(impl);
}

static char *
getValue(union Request_Impl *impl, const char *key)
{
    return Map_get(impl->mappedRequest.map, key);
}

static struct ContentType *
getContentType(union Request_Impl *impl UNUSED, const char *key UNUSED)
{
    return NULL;
}

static int
writeValue(union Request_Impl *impl, const char *key, union OutputTube out)
{
    char *val;

    if ((val = Map_get(impl->mappedRequest.map, key)) == NULL)
	return -1;
    return OutputTube_writeFully(out, val, strlen(val));
}

static const struct Request_Methods METHODS = {
    destroy,
    getValue,
    getContentType,
    writeValue};

struct MappedRequest *
MappedRequest_create(void)
{
    union Request_Impl *impl;

    if ((impl = (union Request_Impl *)malloc(sizeof(*impl))) == NULL)
	return NULL;
    Request_initialize(&impl->request, &METHODS, impl);
    if ((impl->mappedRequest.map = Map_create()) == NULL) {
	destroy(impl);
	return NULL;
    }
    return &impl->mappedRequest;
}
